<?php

function dhcpserver_table_exist()
{
    $sql_table_exist = "select count(*) from sqlite_master where type='table' and name='dhcp_server';";
    $results = sql($sql_table_exist, "getAll");
    return $results[0][0];
}

function dhcpserver_create_table()
{
    global $db;
    $sql = "CREATE TABLE dhcp_server ( 'keyword' varchar(32) NOT NULL, 'data' varchar(32), PRIMARY KEY ('keyword'));";
    $result = $db->query($sql);

    if ( DB::IsError($results) )
    {
        die_freepbx ( $results->getMessage().$sql );
    }
}

function dhcpserver_get_configs()
{
    $sql = "select keyword, data from dhcp_server;";
    $results = sql( $sql, "getAll" );

    if ( DB::IsError ( $results ) ) {
        die_freepbx ( $results->getMessage().$sql );
    }
    return $results;
}

function dhcpserver_put_configs( $keyword, $data )
{
    global $db;
    $sql = "insert into dhcp_server values('$keyword','$data');";
    $results = $db->query( $sql );

    if ( DB::IsError ( $results ) ) {
        die_freepbx ( $results->getMessage().$sql );
    }
}

function dhcpserver_delete()
{
    global $db;
    $sql = "delete from dhcp_server;";
    $results = $db->query( $sql );

    if ( DB::IsError ( $results ) ) {
        die_freepbx ( $results->getMessage().$sql );
    }
}

?>
