<?php
    $dhcpd_conf = "/etc/dhcpd.conf";
    $tmp_dhcpd_conf = "/etc/dhcpd.conf.tmp";
    $checkEnable = isset($_REQUEST['checkEnable']) ? $_REQUEST['checkEnable'] : "";

    if ( !dhcpserver_table_exist() )
    {
        dhcpserver_create_table();       
    }

    if ( $checkEnable == "true" )
    {
        $dhcpip = isset($_REQUEST['dhcpip']) ? $_REQUEST['dhcpip'] : "";
        $staticip = isset($_REQUEST['staticip']) ? $_REQUEST['staticip'] : "";

        $baseIP1 = isset($_REQUEST['baseIP1']) ? $_REQUEST['baseIP1'] : "";
        $baseIP2 = isset($_REQUEST['baseIP2']) ? $_REQUEST['baseIP2'] : "";
        $baseIP3 = isset($_REQUEST['baseIP3']) ? $_REQUEST['baseIP3'] : "";
        $baseIP4 = isset($_REQUEST['baseIP4']) ? $_REQUEST['baseIP4'] : "";
    
        $mask1 = isset($_REQUEST['mask1']) ? $_REQUEST['mask1'] : "";
        $mask2 = isset($_REQUEST['mask2']) ? $_REQUEST['mask2'] : "";
        $mask3 = isset($_REQUEST['mask3']) ? $_REQUEST['mask3'] : "";
        $mask4 = isset($_REQUEST['mask4']) ? $_REQUEST['mask4'] : "";
    
        $startIP = isset($_REQUEST['startIP']) ? $_REQUEST['startIP'] : "";
        $endIP = isset($_REQUEST['endIP']) ? $_REQUEST['endIP'] : "";

        $leaseTime = isset($_REQUEST['leaseTime']) ? $_REQUEST['leaseTime'] : "";
    
        $dns1 = isset($_REQUEST['dns1']) ? $_REQUEST['dns1'] : "";
        $dns2 = isset($_REQUEST['dns2']) ? $_REQUEST['dns2'] : "";
        $dns3 = isset($_REQUEST['dns3']) ? $_REQUEST['dns3'] : "";
        $dns4 = isset($_REQUEST['dns4']) ? $_REQUEST['dns4'] : "";

        $baseIP = $baseIP1.'.'.$baseIP2.'.'.$baseIP3.'.'.$baseIP4;  
        $subnet = $baseIP1.'.'.$baseIP2.'.'.$baseIP3.'.'."0";
        $mask = $mask1.'.'.$mask2.'.'.$mask3.'.'.$mask4;
        $ipStart = $baseIP1.'.'.$baseIP2.'.'.$baseIP3.'.'.$startIP;
        $ipEnd = $baseIP1.'.'.$baseIP2.'.'.$baseIP3.'.'.$endIP;
        $dns = $dns1.'.'.$dns2.'.'.$dns3.'.'.$dns4;

        dhcpserver_delete();
        dhcpserver_put_configs("checkEnable", 1);
        if ( $staticip == "true")
        {
            dhcpserver_put_configs("staticip", 1);
            dhcpserver_put_configs("dhcpip", 0);

            exec("nvram set 8=1");
            exec("nvram set 9=".$baseIP1);
            exec("nvram set 10=".$baseIP2);
            exec("nvram set 11=".$baseIP3);
            exec("nvram set 12=".$baseIP4);

            exec("nvram set 13=".$mask1);
            exec("nvram set 14=".$mask2);
            exec("nvram set 15=".$mask3);
            exec("nvram set 16=".$mask4);

            // set gateway ip
            exec("nvram set 17=".$baseIP1);
            exec("nvram set 18=".$baseIP2);
            exec("nvram set 19=".$baseIP3);
            exec("nvram set 20=".$baseIP4);

            exec("nvram set 21=".$dns1);
            exec("nvram set 22=".$dns2);
            exec("nvram set 23=".$dns3);
            exec("nvram set 24=".$dns4);
        }
        else
        {
            dhcpserver_put_configs("staticip", 0);
            dhcpserver_put_configs("dhcpip", 1);
            exec("nvram set 8=0");
        }
        dhcpserver_put_configs("baseIP", $baseIP);
        dhcpserver_put_configs("mask", $mask);
        dhcpserver_put_configs("startIP", $startIP);
        dhcpserver_put_configs("endIP", $endIP);
        dhcpserver_put_configs("leaseTime", $leaseTime);
        dhcpserver_put_configs("dns", $dns);

        $subnet_head_line = exec( "awk '/^subnet/{ line = FNR; } END{ print line;}' ".$dhcpd_conf );
//        echo "1:".$subnet_head_line."<br>";
        $subnet_end_line = exec("awk '{ if( FNR > ".$subnet_head_line.") { if ( $0 ~ /^}/) { line = FNR; exit; } } } END{ print line;}' ".$dhcpd_conf );
//        echo "2:".$subnet_end_line."<br>";
        exec("awk '{ 
                    if( FNR == ".$subnet_head_line.")
                    { 
                        $2=\"".$subnet."\"; $4=\"".$mask."\"; print $0 >> \"".$tmp_dhcpd_conf."\";
                    } 
                    else if ( FNR > ".$subnet_head_line." && FNR < ".$subnet_end_line." ) 
                    {
                        if ( $0 ~ /range/ )
                        {
                           $2 = \"".$ipStart."\"; $3=\"".$ipEnd.";\""."; 
                        }
                        else if ( $0 ~ /subnet-mask/ )
                        {
                            $3 = \"".$mask.";\";
                        }
                        else if ( $0 ~ /domain-name-servers/ )
                        {
                            $3 = \"".$dns.";\";
                        }   
                        else if ( $0 ~ /default-lease-time/ )
                        {
                            $2= \"".$leaseTime.";\";
                        }
                        print $0 >> \"".$tmp_dhcpd_conf."\";
                    } 
                    else print $0 >> \"".$tmp_dhcpd_conf."\";
            }' ".$dhcpd_conf);
        exec("mv ".$tmp_dhcpd_conf." ".$dhcpd_conf);

        exec("nvram set 5001=1");
    }
    else if( $checkEnable == "false" )
    {
        dhcpserver_delete();
        dhcpserver_put_configs("checkEnable", 0);

        $dhcpip = isset($_REQUEST['dhcpip']) ? $_REQUEST['dhcpip'] : "";
        if ( $dhcpip == "true")
            dhcpserver_put_configs("dhcpip", 1);
        else if ( $dhcpip == "false" )
            dhcpserver_put_configs("dhcpip", 0);
        
        $staticip = isset($_REQUEST['staticip']) ? $_REQUEST['staticip'] : "";
        if ( $staticip == "true" )
            dhcpserver_put_configs("staticip", 1);
        else if ( $staticip == "false" )
            dhcpserver_put_configs("staticip", 0);

        exec("nvram set 5001=0");
    }
    exec("nvram commit");
    $configs = dhcpserver_get_configs();
    if ( $configs )
    {
        foreach ( $configs as $config ) 
        {
            $$config[0] = $config[1];
        }
    }
?>
<head>
<SCRIPT type=text/JavaScript>
    window.onload = function() {
        var index = location.href.indexOf("?");
        module_url = location.href.substr(0, index);
        module_url+="?type=setup&display=dhcpserver";
    }
    
    function alertInfo(info)
    {
        var altInfo = document.getElementById("altInfo");
        altInfo.innerHTML = info;
        altInfo.style.display = "block";
    }

    function dhcpRadioCheck()
    {
        if ( document.getElementById("dhcpip").checked == true )
        {
            document.getElementById("dhcpip").value = "true";
            document.getElementById("staticip").checked = false;
            document.getElementById("staticip").value = "false";
            document.getElementById("checkEnable").checked = false;
            document.getElementById("checkEnable").value = "false";
        }
    }

    function staticRadioCheck()
    {
        if ( document.getElementById("staticip").checked == true )
        {
            document.getElementById("staticip").value = "true";

            document.getElementById("dhcpip").checked = false;
            document.getElementById("dhcpip").value = "false";
        }
    }

    function validate()
    {
        var regStr = /^[0-9]+$/;

        var checkEnable_val = document.getElementById("checkEnable").value;
        if ( checkEnable_val == "false" )
        {
            return 1;
        }

        var baseIP1 = document.getElementById("baseIP1").value;
        var baseIP2 = document.getElementById("baseIP2").value;
        var baseIP3 = document.getElementById("baseIP3").value;
        var baseIP4 = document.getElementById("baseIP4").value;

        if ( !baseIP1.match(regStr) || !baseIP2.match(regStr) || !baseIP3.match(regStr) || !baseIP4.match(regStr) )
        {
            var info = "Please enter a valid Lan Base IP, can contain only numbers of 1~255!";
            alertInfo(info);
            return 0;
        }
        baseIP1_val = parseInt(baseIP1);
        baseIP2_val = parseInt(baseIP2);
        baseIP3_val = parseInt(baseIP3);
        baseIP4_val = parseInt(baseIP4);
        if ( !( baseIP1_val >= 0 && baseIP1_val <=255 && baseIP2_val >= 0 && baseIP2_val <=255 && baseIP3_val >= 0 && baseIP3_val <=255 && 
            baseIP4_val >= 0 && baseIP4_val <=255 ))
        {
            var info = "Please enter a valid Lan Base IP, can contain only numbers of 1~255!";
            alertInfo(info);
            return 0;
        }        

        var mask1 = document.getElementById("mask1").value;
        var mask2 = document.getElementById("mask2").value;
        var mask3 = document.getElementById("mask3").value;
        var mask4 = document.getElementById("mask4").value;

        if ( !mask1.match(regStr) || !mask2.match(regStr) || !mask3.match(regStr) || !mask4.match(regStr) ) 
        {
            var info = "Please enter a valid Lan Subnet Mask, can contain only numbers of 0~255!";
            alertInfo(info);
            return 0;
        }

        mask1_val = parseInt(mask1);
        mask2_val = parseInt(mask2);
        mask3_val = parseInt(mask3);
        mask4_val = parseInt(mask4);

        if ( !( mask1_val >=0 && mask1_val <=255 && mask2_val >=0 && mask2_val <=255 && mask3_val >=0 && mask3_val <=255 && mask4_val >=0 && mask4_val <=255 ) )
        {
            var info = "Please enter a valid Lan Subnet Mask, can contain only numbers of 0~255!";
            alertInfo(info);
            return 0;
        }

        var dns1 = document.getElementById("dns1").value;
        var dns2 = document.getElementById("dns2").value;
        var dns3 = document.getElementById("dns3").value;
        var dns4 = document.getElementById("dns4").value;

        if ( !dns1.match(regStr) || !dns2.match(regStr) || !dns3.match(regStr) || !dns4.match(regStr) )
        {
            var info = "Please enter a valid dns server, can contain only numbers!";
            alertInfo(info);
            return 0;
        }

        dns1_val = parseInt(dns1);
        dns2_val = parseInt(dns2);
        dns3_val = parseInt(dns3);
        dns4_val = parseInt(dns4);

        if ( !( dns1_val >=0 && dns1_val <=255 && dns2_val >=0 && dns2_val <=255 && dns3_val >=0 && dns3_val <=255 && dns4_val >=0 && dns4_val <=255 ) ) 
        {
            var info = "Please enter a valid dns server, can contain only numbers!";
            alertInfo(info);
            return 0;
        }

        var startIP = document.getElementById("startIP").value;
        if ( !startIP.match(regStr) )
        {
            var info = "Please enter a valid start ip, can contain only numbers of 1~255";
            alertInfo(info);
            return 0;
        }
        startIP_val = parseInt(startIP);
        if ( ! (startIP_val >=0 && startIP_val <=255 ) )
        {
            var info = "Please enter a valid start ip, can contain only numbers of 1~255";
            alertInfo(info);
            return 0;
        }

        var endIP = document.getElementById("endIP").value;
        if ( !endIP.match(regStr) )
        {
            var info = "Please enter a valid end ip, can contain only numbers of 1~255";
            alertInfo(info);
            return 0;
        }
        endIP_val = parseInt(endIP);
        if ( ! (endIP_val >=0 && endIP_val <=255 ) )
        {
            var info = "Please enter a valid end ip, can contain only numbers of 1~255";
            alertInfo(info);
            return 0;
        }

        var leaseTime = document.getElementById("leaseTime").value;
        if ( !leaseTime.match(regStr) )
        {
            var info = "Please enter a valid Default Lease Time! can contain only numbers of 600~87600 !";
            alertInfo(info);
            return 0;
        }
        leaseTime_val = parseInt(leaseTime);
        if ( ! ( leaseTime >= 600 && leaseTime <=87600 ) )
        {
            var info = "Please enter a valid Default Lease Time! can contain only numbers of 600~87600 !";
            alertInfo(info);
            return 0;
        }
        return 1;
    }

    function submit()
    {
        if ( !validate() )
            return;

        var checkEnable_val = document.getElementById("checkEnable").value;
        var staticip_val = document.getElementById("staticip").value;
        var dhcpip_val = document.getElementById("dhcpip").value;

        var baseIP1_val = parseInt(document.getElementById("baseIP1").value);
        var baseIP2_val = parseInt(document.getElementById("baseIP2").value);
        var baseIP3_val = parseInt(document.getElementById("baseIP3").value);
        var baseIP4_val = parseInt(document.getElementById("baseIP4").value);

        var mask1_val = parseInt(document.getElementById("mask1").value);
        var mask2_val = parseInt(document.getElementById("mask2").value);
        var mask3_val = parseInt(document.getElementById("mask3").value);
        var mask4_val = parseInt(document.getElementById("mask4").value);

        var dns1_val = parseInt(document.getElementById("dns1").value);
        var dns2_val = parseInt(document.getElementById("dns2").value);
        var dns3_val = parseInt(document.getElementById("dns3").value);
        var dns4_val = parseInt(document.getElementById("dns4").value);

        var startIP_val = parseInt(document.getElementById("startIP").value);

        var endIP_val = parseInt(document.getElementById("endIP").value);

        var leaseTime_val = parseInt(document.getElementById("leaseTime").value);

        location.replace(module_url+"&checkEnable="+checkEnable_val+
        "&baseIP1="+baseIP1_val+"&baseIP2="+baseIP2_val+"&baseIP3="+baseIP3_val+"&baseIP4="+baseIP4_val+
        "&mask1="+mask1_val+"&mask2="+mask2_val+"&mask3="+mask3_val+"&mask4="+mask4_val+
        "&dns1="+dns1_val+"&dns2="+dns2_val+"&dns3="+dns3_val+"&dns4="+dns4_val+
        "&startIP="+startIP_val+
        "&endIP="+endIP_val+
        "&leaseTime="+leaseTime_val+
        "&staticip="+staticip_val+
        "&dhcpip="+dhcpip_val);
    }

    function putVal()
    {
        var checkEnable = document.getElementById("checkEnable");
        if ( checkEnable.checked == true )
        {
            checkEnable.value = "true";
            document.getElementById("dhcpip").checked = false;
            document.getElementById("dhcpip").value = "false";
            document.getElementById("staticip").checked = true;
            document.getElementById("staticip").value = "true";
        }
        else
        {
            checkEnable.value = "false";
        }
    }
</SCRIPT>

    <STYLE type=text/css>

        BODY {
            FONT-SIZE: 12px; 
        }

        h1.module {
            color: gray; font-size: 24px;
        }

        h3.item {
            color: gray; font-size: 16px; height: 10px; margin-top: 30px;
        }

        div.altInfo {
            text-align: center; display: none; width: 550px; border: 5px solid #FFDEAD;
            margin-bottom:10px;font-size:16px; color: red
        }

        div.label {
            color: #555555;
            display: block;
            float: left;
            margin-bottom: 5px;
            margin-top: 8px !important;
            padding-right: 20px;
            text-align: left;
            width: 200px;
        }

        input {
            font-size: 12px;
            border: 1px solid #CCCCCC;
            margin-left: 0;
            width: 30px;
        }

        input.longlen {
            width: 100px;
        }

        input.button {
            background-color: #F8F9FC;
            border-color: #999999 #555555 #555555 #999999;
            border-style: solid;
            border-width: 1px 2px 2px 1px;
            color: #295373;
            font-size: 12px;
            padding: 5px 0;
            text-decoration: none;
            width: 60px;
            margin: 0 65px;
        }

        input.button:hover {
            background-color: #DDE3EC;
        }
 
        div.ipseg {
            display: block;
            float: left;
            font-size: 12px;
            margin-bottom: 5px;
            margin-top: 7px !important;
            width: 200px;
        }

        span.ipsep {
            margin-bottom: 5px;
            margin-top: 8px !important;
            padding: 0 6px 0 7px;
            width: 20px;
        }

        div.default {
            display: block;
            float: left;
            margin-bottom: 5px;
            margin-top: 10px !important;
            width: 50px;
        }

        div.check {
            display: block;
            float: left;
            margin-bottom: 5px;
            margin-top: 8px !important;
        }

        div.button {
             width: 400px; margin-top: 15px; margin-bottom: 20px;
        }

        a.button {
            background-color: #F8F9FC;
            border-color: #999999 #555555 #555555 #999999;
            border-style: solid;
            border-width: 1px 2px 2px 1px;
            color: #295373;
            cursor: pointer;
            font-size: 12px;
            padding: 5px 10px;
            margin: 0 65px;
            text-decoration: none;
            width: 50px;
        }

        a.button:hover {
            background-color: #DDE3EC;
        }

    </STYLE>

</head>
<div id=divDHCP>
    <p><h1 class=module>DHCP Server</h1></p>
    <p><h3 class=item>DHCP Server settings</h3><hr></p>
    <div class=altInfo id=altInfo></div>
    <div style="width: 450px; height: 250px">

        <div class=label><span><b>Address type</b></span>:</div>
        <div class=check><input type=radio class=check id=dhcpip name=dhcpip onclick="dhcpRadioCheck()" <?php
           if ( isset( $dhcpip ) && ( $dhcpip == "1")) 
           {
               echo ' checked=1 value="true" ';
           }
           else
           {
               echo ' value="false" ';
           }
        ?>></div>
        <div class=default><span>DHCP</span></div>
        <div class=check><input type=radio class=check id=staticip name=staticip onclick="staticRadioCheck()" <?php
           if ( isset( $staticip ) && ( $staticip == "0")) 
           {
               echo ' value="false" ';
           }
           else
           {
               echo ' checked=1 value="true" ';
           }
        ?>></div>
        <div class=default><span>Static</span></div>

        <div class=label><span><b>DHCP Enable</b></span>:</div>

        <div class=check><input type=checkbox class=check id=checkEnable name=checkEnable <?php
        if ( isset( $checkEnable ) && ( $checkEnable  == "0" ) )
        {
            echo ' value="false" ';
        }
        else
        {
            echo ' checked=1 value="true" ';
        }
        ?> onclick="putVal()"></div>
        <div class=default><span>YES</span></div>


        <div class=label><span><b>LAN Base IP</b></span>:</div>
        <div class=ipseg>
        <input id=baseIP1 name=baseIP1 type=text <?php
        if ( isset( $baseIP ) )
        {
           $ipsegs = explode(".", $baseIP); 
           echo ' value='.$ipsegs[0];
        }
        ?>><span class=ipsep>.</span>
            <input id=baseIP2 name=baseIP2 type=text <?php
            if ( isset( $ipsegs ) ) echo ' value='.$ipsegs[1];
        ?>><span class=ipsep>.</span>
            <input id=baseIP3 name=baseIP3 type=text <?php
            if ( isset( $ipsegs ) ) echo ' value='.$ipsegs[2];
        ?>><span class=ipsep>.</span>
            <input id=baseIP4 name=baseIP4 type=text <?php
            if ( isset( $ipsegs ) ) echo ' value='.$ipsegs[3];
        ?>>
        </div>
        <div class=label><span><b>LAN Subnet Mask</b></span>:</div>
        <div class=ipseg>
            <input id=mask1 name=mask1 type=text <?php
        if ( isset ( $mask ) )
        {
            $masksegs = explode(".", $mask);
            echo ' value='.$masksegs[0];
        }
        ?>><span class=ipsep>.</span>
            <input id=mask2 name=mask2 type=text <?php
            if ( isset( $masksegs ) ) echo ' value='.$masksegs[1];
        ?>><span class=ipsep>.</span>
            <input id=mask3 name=mask3 type=text <?php
            if ( isset( $masksegs ) ) echo ' value='.$masksegs[2];
        ?>><span class=ipsep>.</span>
            <input id=mask4 name=mask4 type=text <?php
            if ( isset( $masksegs ) ) echo ' value='.$masksegs[3];
        ?>>
        </div>
        <div class=label><span><b>DNS Server</b></span>:</div>
        <div class=ipseg>
            <input id=dns1 name=dns1 type=text <?php
            if ( isset ( $dns ) )
            {
                $dnssegs = explode(".", $dns);
                echo ' value='.$dnssegs[0];
            }
        ?>><span class=ipsep>.</span>
            <input id=dns2 name=dns2 type=text <?php
            if ( isset ( $dnssegs ) ) echo ' value='.$dnssegs[1];
        ?>><span class=ipsep>.</span>
            <input id=dns3 name=dns3 type=text <?php
            if ( isset ( $dnssegs ) ) echo ' value='.$dnssegs[2];
        ?>><span class=ipsep>.</span>
            <input id=dns4 name=dns4 type=text <?php
            if ( isset ( $dnssegs ) ) echo ' value='.$dnssegs[3];
        ?>>
        </div>
        <div class=label><span><b>Start of DHCP IP Pool</b></span>:</div>
        <div class=ipseg>
        <input id=startIP name=startIP type=text class=longlen <?php
            if ( isset( $startIP ) ) echo ' value='.$startIP;
        ?>>
        </div>
        <div class=label><span><b>End of DHCP IP Pool</b></span>:</div>
        <div class=ipseg>
        <input id=endIP name=endIP type=text class=longlen <?php
            if ( isset( $endIP ) ) echo ' value='.$endIP;
        ?>>
        </div>
        <div class=label><span><b>Default IP Lease Time</b></span>:</div>
        <div class=ipseg>
        <input id=leaseTime name=leaseTime type=text class=longlen <?php
            if( isset ( $leaseTime ) ) echo ' value='.$leaseTime;
        ?>>
        </div>
    </div>
    <div class=button>
        <a class=button id=Btn_submt onclick="submit()">Submit</a>
        <a class=button id=Btn_cancel>Cancel</a>
    </div>
</div>
