#define PJ_IOQUEUE_MAX_HANDLES  1000
#define PJSIP_TRANSPORT_SERVER_IDLE_TIME     7200
#define PJSIP_TRANSPORT_IDLE_TIME     7200
#define PJ_ENABLE_EXTRA_CHECK	1
#define PJSIP_EVSUB_TIME_UAC_REFRESH	40

/**Added by vanevan, the default size is 4000, but it is not enough when receive a video call from WebRTC, so change to 8000**/
#define PJSIP_MAX_PKT_LEN			8000
/**
* The default values of PJ_ICE_MAX_CAND, PJ_ICE_ST_MAX_CAND and PJ_ICE_MAX_CHECKS are 16, 8, 32 respectively, and it is not enough in some case.
*
* For example, there are 2 real network interfaces (both are working and using STUN or TURN, and can connect to STUN or TURN server successfully) and 2 virtual network interfaces (it is common if you install a virtual machine),
* so there will be 8 host IP addresses(4 for each RTP and RTCP), and 12 candidates(8 host IP addresses + 4 STUN/TURN reflective addesses)
* if the remote side is working on NAT mode and using STUN or TURN, it will have 2 host IP addresses and 3 candicates(2 host IP addresses + 1 STUN/TURN reflective addesss)
* then the ICE check list size will be 12 * 3 = 36.
*
* Double the default values, that is change to 32, 16 and 64 respectively, these will cover most of the cases
**/
#define PJ_ICE_MAX_CAND				32  /*Default is 16*/
#define PJ_ICE_ST_MAX_CAND			16  /*Default is 8*/
#define PJ_ICE_MAX_CHECKS			64  /*Default is 32*/
